; ===============================================================
; Battle
; ===============================================================

RBattle_Start:
.relocate Init

; ---------------------------------------------------------------
; Battle
; Lets Battle!
; Input: (TeamData)
;	  (OppTeamData)
; Output: ??
; ---------------------------------------------------------------

Battle:
	di
	call BattleVars			; Clears/inits battle vars
	call BattleExtract			; Extract Player team
	call BattleExtract2			; Extract Opp team
	
	ld A, 1				; 'Send out' first player PKMN
	call BattleInit
	ld A, 4				; 'Send out' first opp PKMN
	call BattleInit
	ei
	
	xor A				; init opt = Fight
	ld (BattleMenuX), A
	ld (BattleMenuY), A
	
	call BattleBar
	ld HL, tTrainerWouldLikeToBattle
	call TextboxBlink
	
	res PKMNFlag, (IY + Asm_Flag1)
	rTextbox(tSentOut)
	ld A, 4
	call BattleGraphicsOpp
	
	set PKMNFlag, (IY + Asm_Flag1)
	rTextbox(tGoForIt)
	ld A, 1
	call BattleGraphicsPlayer
	
	call Battle_SandStream		; if player or opp has sand stream, then activate
	call Battle_Intimidate		; if player or opp has intimidate, then activate
	call Battle_Trace			; if player or opp has trace, then activate
	
	jr Battle_Text
	
Battle_Draw:	
	call BattleGraphics
Battle_Text:
	call BattleTxt
	
Battle_Menu:
	call BattleMenu
	
	or A					; if 'Fight' option (0)
	jr z, Battle_Fight			; then goto fight
	dec A					; if 'Bag' option (1)
	jr z, Battle_Bag			; then goto bag
	dec A					; else if 'PKMN' option (2)
	jr z, Battle_PKMN			; then goto pkmn
	jr Battle_Run				; else, goto run
	
Battle_Fight:
	call BattleChoice			; if no choice
	jr nz, Battle_Opp			; then jump to opp move, w/ A = last move
	
	call BattleAtkMenu			; Prompts user to select attack move
	cp $FF
	jr z, Battle_Text			; returns to first menu if Alpha pressed
	
	; //TODO: check PP, message if PP = 0
	
Battle_Opp:
	call BattleAI				; Determine AI opponent move, AF preserved
	
	call Turn				; run single turn
	jr c, Battle_Over2			; jump if battle over
	
	call BattleChoice2			; if no choice
	jr nz, Battle_Opp			; then jump to opp move, w/ A = move
	jr Battle_Text			; else, disp text and menu
	
Battle_Bag:					; disp items message, return to menu
	RCall( cClearText )
	
	di
	rArcText(2, 47, tItemsCantBeUsedNow)
	rCopyBuffSect(0, 48, 96, 14)
	ei
	
	RCall( cWait )				; wait for keypress
	jr Battle_Text
	
Battle_PKMN:					; brings up party menu
	call RParty
	ld A, (PartySwitch)
	or A					; if no switch
	jr z, Battle_Draw			; then go back to menu draw
	call Battle_Redraw
	jr Battle_Opp				; else go to opp move, then turn (A = player move)
	
Battle_Over2:
	jp Battle_Over
	
Battle_Text2:
	jr Battle_Text
	
Battle_Run:
	RCall( cClearText )
	
	di
	call BattleTxtOut
	rArcText(2, 47, tForfeitTheMatch)
	rArcText(2, 56, tAndQuitNow)
	call BattleTxtCopy2
	
	rArcText(61, 47, tYes)
	rArcText(61, 55, tNo)
	call BattleTxtCopy
	ei
	
	ld A, 1
	ld (SelectTeamOptNum), A		; default option is no
	
Battle_RunCur:				; draws cursor
	ld HL, 57 + 55 * 256			; default is (57, 55), no
	ld B, 47
	ld C, L				; clear (57, 47)
	ld A, (SelectTeamOptNum)
	or A
	jr nz, Battle_RunCurNo
	
Battle_RunCurYes:
	ld H, 47				; yes at (57, 47)
	ld B, 55				; clear (57, 55)
	
Battle_RunCurNo:
	ld (PenCol), HL
	ld A, $05				; right pointing arrow
	b_call(_VPutMap)			; display char, BC saved
	ld (PenCol), BC
	ld A, $06				; 4 pixel blank
	b_call(_VPutMap)			; clear out previous option
	rCopyBuffSect(56, 47, 8, 15)	; copy to buffer 2
	
	RCall( cWaitYes )
	jr nc, Battle_RunCur
	;ret
	
	or A					; if A == 1, no option
	jr nz, Battle_Text2			; then go back to menu
	
	xor A					; else, reset savecurrent flag
	ld (PKMNSaveCurrent), A
	ld A, $FE
	ld (BattleWin), A			; set (BattleWin) to $FE, forfeit
	ret					; return to main program flow
	
Battle_Over:
	ld A, (BattleWin)
	inc A ;cp $FF
	ret z					; ret if lose
	
	call Battle_Copy
	
	ld HL, BattleNum
	inc (HL)				; (BattleNum) ++
	ld HL, MatchNum
	ld A, (HL)
	inc A
	ld (HL), A				; (MatchNum) ++
	cp 8
	jr nz, Battle_OverNot8		; if beaten match #7
	
	ld A, 1
	ld (HL), A				; (MatchNum) = 1 
	ld HL, RoundNum
	ld A, (HL)
	inc (HL)				; (RoundNum) ++
	
	set BlinkerOn, (IY + Asm_Flag1)
	rTextbox(tCongratulations)		; display 'congrats' message
	rTextbox(tYouveWon)
	rTextbox(tInRecognition)
	rTextbox(tKeenIntel)
	rTextbox(tWeLookForward)
	res BlinkerOn, (IY + Asm_Flag1)
	
	ld HL, (PKMNSaveBP)			; (PKMNSaveBP) += 5
	ld BC, 5
	add HL, BC
	ld (PKMNSaveBP), HL
	
Battle_OverNot8:
	RCall( cCopySave )
	ret
	
Battle_Copy:					; subroutine - copies data at oppteamdata to prevoppteam
	ld HL, OppTeamData			; copy opp team data into prev opp team
	ld DE, PrevOppTeam			; for use in swapping
	ld BC, 9
	ldir
	ret
	
Battle_Redraw:				; subroutine - saves AF, draws UI + graphics
	push AF
	call BattleGraphics
	pop AF
	ret
	
Battle_Quit:					; erases current data, quits to shell
	xor A
	ld (PKMNSaveCurrent), A		; reset current status, forfeited match
	jp SwapQuit				; swap in overworld code, then quit
	
; ---------------------------------------------------------------
; BattleVars
; Initializes / clears battle vars
; ---------------------------------------------------------------

BattleVars:
	ld HL, Field			; set bytes from Field to Field + 70 to 0
	ld (HL), 0
	ld DE, Field + 1
	ld BC, 64			; clear from +364 to +428
	ldir
	
	xor A				; init pos = (0, 0)
	ld (BatAtkX), A
	ld (BatAtkY), A
	
	res HealFlag, (IY + Asm_Flag2)	; HealFlag = 0, damage by default
	res SwitchFlag, (IY + Asm_Flag2)	; SwitchFlag = 0, switch in battle
	ret
	
; ---------------------------------------------------------------
; BattleExtract
; Extracts PKMN data from team data, initializes vars
; Input: (TeamData) or (OppTeamData)
; Output: (TeamPKMN1) or (OppPKMN1)
; ---------------------------------------------------------------

BattleExtract2:				; Entry point for opp
	ld HL, OppTeamData
	ld DE, OppPKMN1
	jr BattleExtractCont
	
BattleExtract:				; Entry point for player
	ld HL, TeamData
	ld DE, TeamPKMN1
BattleExtractCont:				; HL = in, DE = out
	;RCall( cRBattleExtract )
	;ret
	
	ld B, 3				; 3 pke / team
BattleExtractLp:
	push HL
	push BC
	push HL
	push HL
	push HL
	ld BC, 3				; Tier, #, PID --> (DE), (DE += 2)
	ldir
	pop HL
	RCall( cGetPoke )
	call GetByte			; Species --> A --> (DE)
	ld (DE), A
	inc DE
	inc HL
	ld B, 4				; For(I, 0, 3)
BattleExtractMoveLp:
	call GetByte				; Move[I] --> (DE + 2 + I)
	ld (DE), A
	inc DE
	inc HL
	djnz BattleExtractMoveLp
	call GetByte				; Item --> (DE+6)
	srl A
	srl A
	srl A
	ld (DE), A
	inc HL					; Nature --> (DE+7)
	inc HL
	inc DE
	call GetByte
	and %00011111
	ld (DE), A
	inc DE
	pop HL
	xor A
BattleExtractStatLp:				; For each Stat
	push HL				; Stat --> (DE + 8 + A*2)
	push AF
	push DE
	RCall( cCalcStat )
	pop DE
	ld A, L
	ld (DE), A
	inc DE
	ld A, H
	ld (DE), A
	inc DE
	pop AF
	pop HL
	inc A
	cp 6
	jr nz, BattleExtractStatLp
	pop HL					; Ability --> (DE+20)
	push HL
	push DE
	RCall( cGetAbility )
	pop DE
	ld (DE), A
	inc DE
	push DE
	ex DE, HL				; Max HP --> BC --> (DE+21)
	scf \ ccf
	ld BC, 13
	sbc HL, BC
	ld C, (HL)
	inc HL
	ld B, (HL)
	pop DE
	ld A, C
	ld (DE), A
	inc DE
	ld A, B
	ld (DE), A
	inc DE
	xor A					; Status (None) --> (DE+23)
	ld (DE), A
	inc DE
	pop HL
	RCall( cGetMove )
	ld B, 4				; For each Move...
BattleExtractPPLp:
	push HL
	push BC
	push DE
	call GetByte
	RCall( cGetMovePP )			; Move.PP --> A --> (DE+24+I)
	pop DE
	ld (DE), A
	inc DE
	pop BC
	pop HL
	inc HL
	djnz BattleExtractPPLp
	xor A
	ld (DE), A				; SLPCount (0) --> (DE+28)
	inc DE
	pop BC
	pop HL
	inc HL
	inc HL
	inc HL
	dec B
	jp nz, BattleExtractLp
	ret
	
; ---------------------------------------------------------------
; BattleInit:
; Initializes current PKMN
; Input: A = Team # (1-3 | 4-6)
; Output: (PlayerPKMN) or (OppPKMN)
; ---------------------------------------------------------------

BattleInit:
	cp 4					; If A <= 3
	jr nc, BattleInitOpp			; Then Player --> DE
BattleInitPlayerPKMN:
	ld DE, PlayerPKMN			; Else
	jr BattleInitPlayer			; Opponent --> DE
	
BattleInitOpp:
	ld DE, OppPKMN
BattleInitPlayer:
	;RCall( cRBattleInit )
	;ret
	
	call BattleInitGet
	
	push DE				; save pt to player or opp pkmn
	ld BC, BYTES_PER_TPKMN		; Copies basic info
	ldir
	ld (DE), A				; Sets team #
	
	inc DE					; init other values to 0
	ld H, D
	ld L, E
	inc DE
	ld (HL), 0
	ld BC, 47
	ldir
	pop HL					; get pt to player or opp pkmn as HL
	
	jp BattleInitReset
	
BattleInitGet:				; subroutine - input: A = team num, output: HL = pt to team data, saves AF / DE
	push AF
	push DE				; HL = TeamPKMN1 + (28 * (A - 1))
	dec A
	ld H, A
	ld L, BYTES_PER_TPKMN
	call MultHL
	ld BC, TeamPKMN1
	add HL, BC
	pop DE
	pop AF
	ret
	
BattleInitReset:				; subroutine - input: HL = pt to pkmn data, resets status vars (last / encore / disable / torment move)
	ld A, $FF
	ld BC, PKMN_LastMove			; set last move ID to $FF (None)
	add HL, BC
	ld (HL), A
	inc HL
	ld (HL), A				; set disabled move ID to $FF (None)
	ld BC, PKMN_EncoreMove - PKMN_DisabledMove
	add HL, BC
	ld (HL), A				; set encore move ID to $FF (None)
	ld BC, PKMN_TormentMove - PKMN_EncoreMove
	add HL, BC
	ld (HL), A				; set torment move ID to $FF (None)
	ret
	
; ---------------------------------------------------------------
; Battle bar
; Draws opp and player bars w/ pokeballs
; ---------------------------------------------------------------

BattleBar:
	RCall( cClearBuff )
	call BattleBarOpp
	;call BattleBarPlayer
	;ret
	
BattleBarPlayer:
	;RCall( cRBattleBarP )
	;ret
	
	di
	rHorizLineB(54, 39, 42)		; player bar
	rGSPutSprite(46, 37, sBatBarA)	; player bar flourish
	
	ld B, 6				; draw 6 pokeballs in player bar
	ld A, 90				; x = 90
	ld C, 1				; C = 1 for player
BattleBarLpA:
	push AF
	push BC
	call BattleBarGetBall		; IX = ball sprite, assumes battle code loaded
	ld L, 32				; y = 32
	RCall( cgsPutSprite )
	pop BC
	pop AF
	sub 7					; x -= 7
	djnz BattleBarLpA			; loop until B = 0
	ei
	ret
	
BattleBarOpp:
	;RCall( cRBattleBarO )
	;ret
	
	di
	rDrawRectW3(0, 0, 56, 19)		; clear area
	rHorizLineB(0, 17, 42)		; opp bar
	rGSPutSprite(42, 15, sBatBar)	; opp bar flourish
	
	ld B, 6				; draw 6 pokeballs in opp bar
	xor A					; x = 0
	ld C, A				; C = 0 for opp
BattleBarLp:
	push AF
	push BC
	call BattleBarGetBall		; IX = ball sprite, assumes battle code loaded
	ld L, 10				; y = 10
	RCall( cgsPutSprite )
	pop BC
	pop AF
	add A, 7				; x += 7
	djnz BattleBarLp			; loop until B = 0
	ei
	ret
	
BattleBarGetBall:				; subroutine - gets ball sprite, input: A = x, B = iteration, C = player, output: IX = ball, saves A
	cp 16					; if x < 16
	jr c, BattleBarEmpty			; then draw empty pokeball
	cp 72					; if x >= 72
	jr nc, BattleBarEmpty		; then draw empty pokeball
	
	ld D, A				; save A in D
	ld A, C
	or A
	ld A, 3
	jr z, BattleBarGetBallOpp		; if not (C = 0)
	xor A					; then player, A = 0
	
BattleBarGetBallOpp:				; else opp, A = 3
	add A, B				; A = 3 + B, (6, 5, 4 for opp), (3, 2, 1 for player)
	call BattleInitGet			; HL = pt to opp pkmn data, AF / DE saved
	ld BC, PKMN_Status
	add HL, BC
	ld A, (HL)				; A = pkmn status
	cp stFNT
	jr z, BattleBarFNT
	or A
	ld A, D				; restore A from D, flags unchanged
	jr nz, BattleBarStatus
	
	ld IX, sPokeball			; normal pokeball, otherwise
	ret
	
BattleBarFNT:					; FNT pokeball, for status = FNT
	ld A, D				; restore A from D, flags unchanged
	ld IX, sFNTBall
	ret
	
BattleBarStatus:				; darked pokeball, for status != stNone
	ld IX, sStatusBall
	ret
	
BattleBarEmpty:				; empty pokeball
	ld IX, sEmptyBall
	ret
	
; ---------------------------------------------------------------
; BattleTxt
; Writes textual information - prompt, options 
; Input: (PlayerPKMN), (OppPKMN)
; ---------------------------------------------------------------

BattleTxt:
	;RCall( cRBattleTxt )
	;ret
	
	RCall( cClearText )
	
	di
	call BattleTxtOut
	rVPutS(61, 47, tFight)
	rVPutS(82, 47, tBag)
	rVPutS(61, 55, tPKMN)
	rVPutS(82, 55, tRun)
	call BattleTxtCopy
	ei
	
	di
	rVPutS(2, 47, tWhatWill)	; Prompt text
	ld A, (PlayerPKMN + PKMN_Species)
	RCall( cGetName3 )		; Player PKMN Name
	rTextCoord(2, 56)
	ld A, 20
	ld (TextSize), A		; size limit is 20
	RCall( cArcTextDc )
	ld B, 10
	RCall( cPutSN )
	ld HL, tDo
	b_call(_VPutS)
	call BattleTxtCopy2
	ei
	ret
	
BattleTxtOut:					; subroutine - draws texbox outlines for menu
	rDrawBoxOut(0, 45, 96, 19)		; textbox outline
	rVertLineB(54, 46, 17)		; textbox stuff
	rDrawBoxOutD(55, 46, 40, 17)	; inner gray lining of textbox
	ret
	
BattleTxtCopy:				; subroutine - copies right side of textbox
	rCopyBuffSect(56, 47, 38, 15)
	ret
	
BattleTxtCopy2:				; subroutine - copies left side of textbox
	rCopyBuffSect(2, 48, 52, 14)
	ret
	
; ---------------------------------------------------------------
; BattleGraphics
; Draws misc graphics - Names, Gender, HP
; ---------------------------------------------------------------

BattleGraphics:
	RCall( cClearBuff )
	call BattleGraphicsPlayer
	jp BattleGraphicsOpp
	
BattleGraphicsPlayer:
	ld A, (PlayerFainted)
	or A
	ret nz					; ret if player fainted
	
BattleGraphicsPlayer2:
	;RCall( cRBattleGxPlayer )
	;ret
	
	di
	rFillBuffSect(WFill, 40, 26, 56, 18)
	rDrawBoxOut(45, 26, 50, 16)		; player box
	rHorizLineB(41, 42, 51)		; player box flourishes
	rHorizLineB(40, 43, 51)
	rGSPutSprite(37, 39, sBatDesA)
	
	ld A, (PlayerPKMN + PKMN_Species)
	RCall( cGetName3 )			; Player PKMN Name
	rTextCoord(47, 27)
	ld A, 20 ;;;
	ld (TextSize), A
	RCall( cArcTextDc )
	ld B, 10
	RCall( cPutSN )
	;ld B, 10
	;RCall( cArcTextN )
	ld HL, PlayerPKMN 			; Player PKMN gender
	RCall( cDispGenderCoord )		; disp gender at text coordinates
	
	rCopyBuffSect(46, 27, 47, 8)
	ld DE, PlayerPKMN
	ld A, 1				; A = 1 for player
	RCall( cDispHP )			; HP boxes
	
	ld A, (PlayerPKMN + PKMN_Status)	; A = status ailment	
	RCall( cDispStatusPlayer )		; disp status (A)
	call BattleGraphicsPlayerSprite	; assumes that battle code is loaded
	ei
	ret
	
BattleGraphicsPlayerSprite:
	ld HL, PlayerPKMN
	call GetPKMNSub			; A = sub status of pkmn
	ld A, pSubstitute
	jr nz, BattleGraphicsPlayerSprite2	; A = pSubstitute, if sub status != 0
	
	RCall( cGetPokeID )			; A = player pkmn number, otherwise
	
BattleGraphicsPlayerSprite2:
	rArcBack(15, 20)			; display back sprite
	ret
	
BattleGraphicsOpp:
	ld A, (OppFainted)
	or A
	ret nz					; ret if opp fainted
	
BattleGraphicsOpp2:
	;RCall( cRBattleGxOpp )
	;ret
	
	di
	rFillBuffSect(WFill, 0, 0, 56, 20)
	rDrawBoxOut(1, 1, 50, 16)		; opponent box
	rHorizLineB(4, 17, 51)		; opponent box flourishes
	rHorizLineB(5, 18, 51)
	rGSPutSprite(51, 14, sBatDes)
	
	ld A, (OppPKMN + PKMN_Species)
	RCall( cGetName3 )		; Opp PKMN Name
	rTextCoord(3, 2)
	ld A, 20 ;;;
	ld (TextSize), A
	RCall( cArcTextDc )
	ld B, 10
	RCall( cPutSN )
	;ld B, 10
	;RCall( cArcTextN )
	ld HL, OppPKMN		; Opp PKMN gender
	ld A, (PenCol)		; End of name
	ld B, A
	ld A, (PenRow)
	ld C, A
	RCall( cDispGender )
	
	rCopyBuffSect(3, 2, 47, 8)
	ld DE, OppPKMN
	ld A, 2			; A = 2 for opponent
	RCall( cDispHP )
	
	ld A, (OppPKMN + PKMN_Status)	; A = status ailment
	RCall( cDispStatusOpp )		; disp status (A)
	call BattleGraphicsOppSprite	; assumes that battle code is loaded
	ei
	ret
	
BattleGraphicsOppSprite:
	ld HL, OppPKMN
	call GetPKMNSub			; A = sub status of pkmn
	ld A, pSubstitute
	jr nz, BattleGraphicsOppSprite2	; A = pSubstitute, if sub status != 0
	
	RCall( cGetPokeID )			; A = opp pkmn number, otherwise
	
BattleGraphicsOppSprite2:
	rArcFront(59, 1)
	ret
	
; ---------------------------------------------------------------
; BattleMenu
; Cursor control and select
; Output: A = Select option
;           = 0 = Fight
;           = 1 = Bag
;           = 2 = PKMN
;           = 3 = Run
; ---------------------------------------------------------------

BattleMenu:
	;RCall( cRBattleMenu )
	;ret
	
	BattleMenuCursor:
	call BattleMenuPos
	ld A, $05			; right-pointing cursor thing
	call BattleMenuChar
	
BattleMenuLp:
	RCall( cGetInput ) ;b_call(_GetCSC)
	or A
	jr z, BattleMenuLp
	
	cp gk2nd
	jr z, BattleMenuA
	cp gkEnter
	jr z, BattleMenuA
	cp gkUp
	jr z, BattleMenuUp
	cp gkDown
	jr z, BattleMenuDown
	cp gkRight
	jr z, BattleMenuRight
	cp gkLeft
	jr z, BattleMenuLeft
	
	cp skMode			; TEMPORARY
	jp z, Quit
	
	jr BattleMenuLp
	
BattleMenuA:
	ld A, (BattleMenuY)		; return X + Y*2
	add A, A			; (0, 0) - 0
	ld B, A			; (1, 0) - 1
	ld A, (BattleMenuX)		; (0, 1) - 2
	add A, B			; (1, 1) - 3
	ret
	
BattleMenuUp:
	ld HL, BattleMenuY
	ld A, (HL)
	or A
	jr z, BattleMenuLp		; return if cursor on top
	call BattleMenuClear		; clear cursor, saves HL
	dec (HL)			; dec cursor position
	jr BattleMenuCursor
	
BattleMenuDown:
	ld HL, BattleMenuY
	ld A, (HL)
	or A
	jr nz, BattleMenuLp		; return if cursor on bottom
	call BattleMenuClear		; clear cursor, saves HL
	inc (HL)			; inc cursor position
	jr BattleMenuCursor 

BattleMenuRight:
	ld HL, BattleMenuX
	ld A, (HL)
	or A
	jr nz, BattleMenuLp		; return if cursor on right
	call BattleMenuClear		; clear cursor, saves HL
	inc (HL)			; inc cursor position
BattleMenuCursor2:
	jr BattleMenuCursor

BattleMenuLeft:
	ld HL, BattleMenuX
	ld A, (HL)
	or A
	jr z, BattleMenuLp		; return if cursor on left
	call BattleMenuClear		; clear cursor, saves HL
	dec (HL)			; dec cursor position
	jr BattleMenuCursor2
	
BattleMenuClear:			; subroutine - clears out cursor loc
	call BattleMenuPos
	ld A, $06
	jr BattleMenuChar
	
BattleMenuPos:			; subroutine - get position of cursor
	ld A, (BattleMenuX)
	or A
	ld A, 57			; X = 57 | 78
	jr z, BattleMenuX0		; if A = 1
	add A, 78 - 57		; then X = 78
BattleMenuX0:
	ld (PenCol), A		; else X = 57
	
	ld A, (BattleMenuY)
	or A
	ld A, 47			; Y = 47 | 55
	jr z, BattleMenuY0		; if A = 1
	add A, 8			; then Y = 55
BattleMenuY0:
	ld (PenRow), A		; else Y = 47
	ret
	
BattleMenuChar:			; subroutine - disps char (A), saves HL
	push HL
	b_call(_VPutMap)
	rCopyBuffSect(56, 47, 38, 15)
	pop HL
	ret
	
; ---------------------------------------------------------------
; BattleAtkMenu
; Attack select
; Input: (PlayerPKMN)
; Output: A = Move ID ($FF if return)
; ---------------------------------------------------------------

BattleAtkMenu:
	;RCall( cRBattleAtkMenu )
	;ret
	
	RCall( cClearText )
	
	di
	ld HL, PlayerPKMN + 4	; move offset
	ld DE, BattleAtkMenuTxtDb
	ld B, 4
BattleAtkMenuMove:
	push BC
	push HL
	push DE
	ex DE, HL
	call LdHLIndRAM
	ld (PenCol), HL
	ex DE, HL
	ld A, (HL)
	RCall( cGetMoveText )
	RCall( cArcText )
	pop DE
	inc DE
	inc DE
	pop HL
	inc HL
	pop BC
	djnz BattleAtkMenuMove
	
BattleAtkMenuCursor:
	call BattleAtkMenuPos
	ld A, H
	RCall( cCopyBuffSect )
	ei
	
BattleAtkMenuLp:
	RCall( cGetInput ) ;b_call(_GetCSC)
	or A
	jr z, BattleAtkMenuLp
	
	cp gk2nd
	jr z, BattleAtkMenuA
	cp gkEnter
	jr z, BattleAtkMenuA
	cp gkAlpha
	jr z, BattleAtkMenuB
	cp gkClear
	jr z, BattleAtkMenuB
	cp gkUp
	jr z, BattleAtkMenuUp
	cp gkDown
	jr z, BattleAtkMenuDown
	cp gkLeft
	jr z, BattleAtkMenuLeft
	cp gkRight
	jr z, BattleAtkMenuRight
	
	jr BattleAtkMenuLp
	
BattleAtkMenuA:
	ld A, (BatAtkY)		; return X + Y*2
	add A, A			; (0, 0) - 0
	ld B, A			; (1, 0) - 1
	ld A, (BatAtkX)		; (0, 1) - 2
	add A, B			; (1, 1) - 3
	ld HL, PlayerPKMN + 4	; move offset
	ld B, 0
	ld C, A
	add HL, BC
	ld A, (HL)
	ret
	
BattleAtkMenuB:
	ld A, $FF
	ret

BattleAtkMenuUp:
	ld A, (BatAtkY)
	or A
	jr z, BattleAtkMenuLp
	call BattleAtkMenuClear
	ld A, (BatAtkY)
	dec A
	ld (BatAtkY), A
	jr BattleAtkMenuCursor
	
BattleAtkMenuDown:
	ld A, (BatAtkY)
	or A
	jr nz, BattleAtkMenuLp
	call BattleAtkMenuClear
	ld A, (BatAtkY)
	inc A
	ld (BatAtkY), A
	jr BattleAtkMenuCursor

BattleAtkMenuLeft:
	ld A, (BatAtkX)
	or A
	jr z, BattleAtkMenuLp
	call BattleAtkMenuClear
	ld A, (BatAtkX)
	dec A
	ld (BatAtkX), A
BattleAtkMenuCursor2:
	jr BattleAtkMenuCursor
	
BattleAtkMenuRight:
	ld A, (BatAtkX)
	or A
	jr nz, BattleAtkMenuLp
	call BattleAtkMenuClear
	ld A, (BatAtkX)
	inc A
	ld (BatAtkX), A
	jr BattleAtkMenuCursor2
	
BattleAtkMenuPos:			; subroutine - positions cursor
	ld H, 2
	ld A, (BatAtkX)
	or A
	jr z, BattleAtkMenuCursorX0
	ld A, 48 - 2
	add A, H
	ld H, A
BattleAtkMenuCursorX0:
	ld L, 47
	ld A, (BatAtkY)
	or A
	jr z, BattleAtkMenuCursorY0
	ld A, 10
	add A, L
	ld L, A
BattleAtkMenuCursorY0:
	ld BC, 46 * 256 + 5
	ret
	
BattleAtkMenuClear:			; subroutine - clears cursor position
	call BattleAtkMenuPos
	RCall( cDrawRectWhite2 )
	ret

BattleAtkMenuTxtDb:
.db 2, 46, 48, 46, 2, 56, 48, 56

; ---------------------------------------------------------------
; BattleAI
; Chooses opponent move
; Input: (OppPKMN)
; Output: B = Move ID
; Preserves AF
; ---------------------------------------------------------------
; TODO: if move PP = 0 and total PP != 0, then choose other move
; TODO: if cannot do more than 30 damage, then switch out
BattleAI:
	push AF
	ld HL, OppPKMN + PKMN_LastMove
	ld B, (HL)
	ld A, B
	cp $FF				; if first turn (no last move)
	jr z, BattleAITree		; then choice, use tree
	
	ld A, (OppPKMN + PKMN_Stall)
	or A				; if stall move
	jr nz, BattleAIEvasion	; then same move as before
	ld A, (OppPKMN + PKMN_Solar)
	or A				; if charged solarbeam
	jr nz, BattleAISolar		; then same move as before
	ld A, (OppPKMN + PKMN_SkyAttack)
	or A				; if charged sky attack
	jr nz, BattleAISkyAttack	; then same move as before
	ld A, (OppPKMN + PKMN_Rollout)
	or A				; if rollout
	jr nz, BattleAIRollout	; then same move as before (rollout)
	ld A, (OppPKMN + PKMN_Duration)
	or A				; if duration move
	jr nz, BattleAIDuration	; then same move as before (petal dance, thrash)
	ld DE, OppPKMN + PKMN_Charge
	ld A, (DE)
	ld B, $FC
	or A				; if A != 0, (A == 1)
	ld A, 0			; unconditionally reset charge status
	ld (DE), A
	jr nz, BattleAICharge	; then return B = $FC, charge signal
	ld A, (OppPKMN + PKMN_Item)
	cp iChoiceBand		; if item is not choice band
	jr nz, BattleAITree		; then skip choice band activation check
	ld A, (OppPKMN + PKMN_Choice)
	ld B, (HL)
	or A				; if choice band activated
	jr nz, BattleAIChoice	; then same move as before
	
BattleAITree:
	call AITree			; B = move
BattleAIMoveSkipRand:
	
BattleAIEvasion:
BattleAICharge:
BattleAISolar:
BattleAISkyAttack:
BattleAIRollout:
BattleAIDuration:
BattleAIChoice:
	pop AF
	ret
	
; ---------------------------------------------------------------
; BattleChoice
; Determines whether player has choice in move
; Input: (PlayerPKMN)
; Output: z = choice, nz = no choice
;	   A = last move (if no choice)
; ---------------------------------------------------------------

BattleChoice:
	ld HL, PlayerPKMN + PKMN_LastMove
	ld B, (HL)
	ld A, B
	cp $FF				; if first turn / no last move
	ret z				; then choice, ret w/ z
	
	ld A, (PlayerPKMN + PKMN_Item)
	cp iChoiceBand		; if player item is not choice band
	jr nz, BattleChoiceNotBand	; then skip choice band activation check
	ld A, (PlayerPKMN + PKMN_Choice)
	or A				; if choice band not activated
	jr z, BattleChoiceNotBand	; then skip, player has choice
	inc A				; A = 1 + 1, set nz
	ld A, B			; A = last move
	ret nz				; ret nz if choice band activated
	
BattleChoiceNotBand:
BattleChoiceYes:
	xor A
	ret				; ret z otherwise
	
; ---------------------------------------------------------------
; BattleChoice2
; Determines whether player has choice in move / switch
; Input: (PlayerPKMN)
; Output: z = choice, nz = no choice
;	   A = move (if no choice)
; ---------------------------------------------------------------
	
BattleChoice2:
	ld HL, PlayerPKMN + PKMN_LastMove
	ld B, (HL)
	ld A, B
	cp $FF				; if first turn / no last move
	ret z				; then choice, ret w/ z
	
	ld HL, PlayerPKMN + PKMN_Stall
	ld A, (HL)
	or A
	ld A, B			; A = last move
	ret nz				; ret nz if stall move
	
	ld A, (PlayerPKMN + PKMN_Solar)
	or A
	ld A, mSolarbeam		; A = move, solarbeam
	ret nz				; ret no choice, if charged solarbeam
	
	ld A, (PlayerPKMN + PKMN_SkyAttack)
	or A
	ld A, mSkyAttack		; A = move, sky attack
	ret nz				; ret no choice, if charged solarbeam
	
	ld A, (PlayerPKMN + PKMN_Rollout)
	or A
	ld A, B			; A = last move, should be rollout
	ret nz
	
	ld A, (PlayerPKMN + PKMN_Duration)
	or A
	ld A, B			; A = last move, should be petal dance / thrash
	ret nz
	
	ld A, (PlayerPKMN + PKMN_Charge)
	or A				; if not charge
	ret z				; then ret z, continue to text
	xor A
	ld (PlayerPKMN + PKMN_Charge), A	; reset charge status
	inc A				; A = 0 + 1, flag = nz
	ld A, $FC			; A = $FC, charge signal
	ret				; ret w/ nz
	
; ---------------------------------------------------------------
; Battle_SandStream
; Checks player and opp pkmn for sandstream, activates sandstorm
; Subroutine preserves HL, DE
; ---------------------------------------------------------------

Battle_SandStream:
	;call Turn_SetPriority	; set priority, slower pkmn determines weather, in case of SandStream / Drought
	ld BC, Battle_SandStreamCalc
	jp Turn_Order
	
Battle_SandStreamCalc:		; HL = pt to pkmn data, ret nc
	call Battle_SandStreamCalc2
	or A				; reset c flag
	ret
	
Battle_SandStreamCalc2:		; HL = pt to pkmn data
	call GetPKMNAbility		; A = pkmn ability, HL, DE preserved
	cp aSandStream		; if ability not sand stream
	ret nz				; then ret
	
	ld (TextAbil), A		; set (TextAbil) to sand stream ID, for textbox msg
	
	push HL			; save HL
	ld HL, Weather
	ld A, (HL)
	pop BC				; get HL as BC
	cp wSandstorm			; if sandstorm already activated
	ret z				; then ret
	
	push BC			; save HL as BC
	ld (HL), wSandstorm		; otherwise, set weather to sandstorm
	inc HL				; WeatherCount - Weather = 1
	ld (HL), $FF			; sandstorm lasts indefinitely
	pop HL				; get HL
	
	rTextbox(tPKMNWhippedSandstorm); textbox saves all registers
	ret
	
; ---------------------------------------------------------------
; Battle_Intimidate
; Checks player and opp pkmn for intimidate, activates ability
; Subroutine preserves HL, DE
; ---------------------------------------------------------------

Battle_Intimidate:
	ld BC, Battle_IntimidateCalc
	jp Turn_Order
	
Battle_IntimidateCalc:		; HL = pt to pkmn data, DE = pt to target data, ret nc
	call Battle_IntimidateCalc2
	or A
	ret
	
Battle_IntimidateCalc2:		; HL = pt to pkmn data, DE = pt to target data
	call GetPKMNAbility		; A = pkmn ability, HL, DE preserved
	cp aIntimidate		; if ability not intimidate
	ret nz				; then ret
	
	ld (TextAbil), A		; set (TextAbil) to intimidate ID, for textbox msg
	ld (TargetPKMN), DE		; set TargetPKMN to DE, for textbox msg
	
	ex DE, HL			; HL = pt to TargetPKMN
	call GetPKMNAbility		; A = pkmn ability, HL, DE preserved
	cp aClearBody
	ex DE, HL
	jr z, Battle_IntimidateClearBody
	
	call IsTargetSub		; ret nz if target pkmn has sub, preserves HL, DE
	ret nz				; return w/o message if target has sub
	
	push HL			; save HL
	push DE			; save DE
	ld HL, PKMN_AtkBoost
	add HL, DE			; HL = pt to atk boost of target pkmn
	;call AE_StatLowerAtk1	 ; lower attack by 1 stage (?)
	ld A, qAtkLower2		; lower attack by 2 stages
	call AttackEffect_CallSilent
	pop DE				; get DE
	pop HL				; get HL
	
	rTextbox(tIntimidateCutsAttack); textbox saves all registers
	
	jp Attack_WhiteHerbSub	; use white herb if available
	
Battle_IntimidateClearBody:
	ld (TextAbil), A		; set (TextAbil) to target ability (aClearBody)
	jp AttackEffect_StatLowerClearBodyDisp
	
	; TODO: disp message for atk won't go lower
	
; ---------------------------------------------------------------
; Battle_Trace
; Checks player and opp pkmn for trace, activates ability
; Subroutine preserves HL, DE
; ---------------------------------------------------------------
	
Battle_Trace:
	ld BC, Battle_TraceCalc
	jp Turn_Order
	
Battle_TraceCalc:			; HL = pt to pkmn data, DE = pt to target data, ret nc
	call Battle_TraceCalc2
	or A
	ret
	
Battle_TraceCalc2:			; HL = pt to pkmn data, DE = pt to target data
	call GetPKMNAbility2		; A = pkmn ability, HL, DE preserved
	cp aTrace			; if ability not trace
	ret nz				; then ret
	
	ld (TargetPKMN), DE		; set TargetPKMN to DE, for textbox msg (TxtTarget, TxtAbil)
	
	push HL			; save HL
	push DE			; save DE
	ld BC, PKMN_Trace		; BC = offset value of trace
	add HL, BC			; HL = pt to pkmn trace value
	ex DE, HL			; HL = pt to target, DE = pt to pkmn trace value
	call GetPKMNAbility2		; A = target ability
	ld (DE), A			; set traced ability to A
	ld (TextAbil), A		; set (TextAbl) to A
	pop DE				; get DE
	pop HL				; get HL
	
	rTextbox(tPKMNTracedAbility); textbox saves all registers
	ret
	
; ---------------------------------------------------------------
; Battle_Spikes
; Check field for spikes, deal damage
; ---------------------------------------------------------------
	
Battle_Spikes:			; HL = pt to pkmn data, DE = pt to target data, (PKMNFlag) = user
	push HL
	push DE
	call Battle_Spikes2
	pop DE
	pop HL
	ret
	
Battle_Spikes2:
	ld E, eFlying
	call PKMNIsType		; if pkmn is flying type, HL preserved
	ret z				; then ret w/ nc, no damage
	call GetPKMNAbility		; A = pkmn ability, HL preserved
	cp aLevitate			; if pkmn has levitate
	ret z				; then ret w/ nc, no damage
	
	ex DE, HL			; DE = pt to pkmn data
	call GetLight			; HL = pt to field of pkmn
	inc HL \ inc HL \ inc HL	; HL += 3, HL pt to spikes var of pkmn
	ld A, (HL)			; A = number of spikes of pkmn
	ex DE, HL			; HL = pt to pkmn data
	or A
	ret z				; ret w/ nc if no spikes
	
	dec A
	jr nz, Battle_SpikesNot1	; if one layer of spikes
	call GetEighthMaxHP		; then HL = 1/8 HP
	jr Battle_SpikesCont
	
Battle_SpikesNot1:
	dec A
	jr nz, Battle_SpikesNot2	; else if two layers of spikes
	call GetSixthMaxHP		; then HL = 1/6 HP
	jr Battle_SpikesCont
	
Battle_SpikesNot2:
	call GetFourthMaxHP		; else, HL = 1/4 HP
	
Battle_SpikesCont:
	RCall( cDoDamage )		; do damage, TODO: spikes damage rounds up?
	call c, Turn_Fainted		; return c if all pkmn fainted
	rTextbox(tPKMNIsHurtBySpikes)
	ret				; ret w/ c if all pkmn fainted
	