; ===============================================================
; Misc.
; ===============================================================

; uncomment to do unit test
;#define TEST
;#define TEST_ROAR

#define XX		666	; null variable, use for routines w/ parameter range(0, 255)
#define WFill		0	; fill byte for a white fill
#define BFill		$FF	; fill byte for a black fill

; PlotSScreen = $9340
; SaveSScreen = $86EC
; Difference = 3156

; ---------------------------------------------------------------
; Gender
; ---------------------------------------------------------------

#define Genderless	%11111111
#define Female100	%11111110
#define Male100	%00000000

; ---------------------------------------------------------------
; Textbox special chars
; ---------------------------------------------------------------

#define TxtE		$96	; accented e in Pokemon
#define TxtNew	$FF	; newline signal
#define TxtEnd	$FE	; end message signal
#define TxtAtk	$FD	; disp AtkPKMN name
#define TxtMove	$FC	; disp atk move
#define TxtTeam	$FB	; disp 'Ally' or 'Foe'
#define TxtTrgt	$FA	; disp TargetPKMN name
#define TxtNum	$F9	; disp arbitrary number
#define TxtAbil	$F8	; disp target PKMN's ability NOT IMPL
#define TxtPKMN	$F7	; disp abitrary pokemon
#define TxtStat	$F6	; disp arbitrary stat
#define TxtScreen	$F5	; disp screen (light/reflect) NOT IMPL
#define TxtMove2	$F4	; disp opp's move NOT IMPL
#define TxtItem	$F3	; disp arbitrary item
#define TxtMove3	$F2	; disp arbitrary move

; ---------------------------------------------------------------
; Stats
; ---------------------------------------------------------------

#define stHP		0
#define stAtk		1
#define stDef		2
#define stSAtk	3
#define stSDef	4
#define stSpd		5
#define stAcc		6
#define stEva		7

#define stPoisoning	16
#define stSleep	17
#define stBurns	18
#define stRomance	19
#define stConfusion	20
#define stItemTheft	21
#define stFlinching	22
#define stOHKOs	23
#define stBurn	24
#define stParalyz	25
#define stPoison	26
#define stStat	27

; ---------------------------------------------------------------
; Status
; ---------------------------------------------------------------

#define stNone	0
#define stBRN		1
#define stFRZ		2
#define stPAR		3
#define stPSN		4
#define stSLP		5
#define stBADPSN	6
#define stFNT		7	; must be last status

; ---------------------------------------------------------------
; Weather
; ---------------------------------------------------------------

#define wNone		0
#define wSun		1
#define wRain		2
#define wSandstorm	3
#define wHail		4

; ---------------------------------------------------------------
; Evasion
; ---------------------------------------------------------------

#define evNone	0
#define evBounce	1
#define evDig		2
#define evDive	3
#define evFly		4

; ---------------------------------------------------------------
; Move flags
; ---------------------------------------------------------------

#define mfNone	%00000000
#define mfProtect	%00000001
#define mfContact	%00000010
#define mfFlinch	%00000100
#define mfSound	%00001000
#define mfFNT		%00010000

; ---------------------------------------------------------------
; PKMN offsets
; ---------------------------------------------------------------

#define PKMN_Tier		00
#define PKMN_PkeID 		01
#define PKMN_PID		02
#define PKMN_Species		03
#define PKMN_Moves		04
#define PKMN_Item		08
#define PKMN_Nature		09
#define PKMN_MaxHP		10
#define PKMN_Atk		12
#define PKMN_Def		14
#define PKMN_SAtk		16
#define PKMN_SDef		18
#define PKMN_Spd		20
#define PKMN_Abil		22
#define PKMN_HP		23
#define PKMN_Status		25
#define PKMN_PP		26
#define PKMN_SLPCount	30

#define PKMN_TeamNum		31
#define PKMN_AtkBoost	32
#define PKMN_DefBoost	33
#define PKMN_SAtkBoost	34
#define PKMN_SDefBoost	35
#define PKMN_SpdBoost	36
#define PKMM_AccBoost	37
#define PKMN_EvaBoost	38
#define PKMN_BadPSN		39
#define PKMN_Yawn		40
#define PKMN_LastMove	41
#define PKMN_DisabledMove	42
#define PKMN_DisableCount	43
#define PKMN_Leech		44
#define PKMN_EncoreMove	45
#define PKMN_EncoreCount	46
#define PKMN_Infatuation	47
#define PKMN_Confusion	48
#define PKMN_PrevEscape	49
#define PKMN_PerishCount	50
#define PKMN_Protect		51
#define PKMN_Counter		52
#define PKMN_Endure		53
#define PKMN_Stall		54
#define PKMN_Flinch		55
#define PKMN_Focus		56
#define PKMN_HP25		57
#define PKMN_HP50		58
#define PKMN_Charge		59
#define PKMN_Trap		60
#define PKMN_Solar		61
#define PKMN_Rollout		62
#define PKMN_DefCurl		63
#define PKMN_Ingrain		64
#define PKMN_Torment		65
#define PKMN_TormentMove	66
#define PKMN_Truant		67
#define PKMN_Trace		68
#define PKMN_FlashFire	69
#define PKMN_Choice		70
#define PKMN_SkillSwap	71
#define PKMN_Destiny		72
#define PKMN_Grudge		73
#define PKMN_Nightmare	74
#define PKMN_SkyAttack	75
#define PKMN_Duration	76
#define PKMN_Substitute	77

#define pSubstitute		109

; ---------------------------------------------------------------
; AI constants
; ---------------------------------------------------------------

#define aiLvl1		%00000000	; style
#define aiLvl2		%01000000	; attack
#define aiLvl3		%10000000	; heal
#define aiLvl4		%11000000	; strategy

#define aiAttack		0
#define aiHeal		1
#define aiHP50		2
#define aiStatHigh		3
#define aiBoost		4
#define aiTrgtStatus		5
#define aiStatus		6
#define aiPrevProtect	7
#define aiProtect		8
#define aiHasStatus		9
#define aiCure		10
#define aiStatLow		11
#define aiLower		12
#define aiIsWeather		13
#define aiWeather		14

; ---------------------------------------------------------------
; Save data constants
; ---------------------------------------------------------------

#define SAVE_Wins		8
#define SAVE_Team		60
#define SAVE_Opp		69
#define SAVE_Prev		78
#define SAVE_Battles		87
#define SAVE_Rounds		89
#define SAVE_Matches		90
#define SAVE_Swaps		91
#define SAVE_Current		93

; ---------------------------------------------------------------
; Grayscale key constants
; ---------------------------------------------------------------

#define gkOn			0
#define gkDown		1
#define gkLeft		2
#define gkRight		3
#define gkUp			4
#define gkEnter		5
#define gk2nd			6
#define gkAlpha		7
#define gkClear		8
#define gkDel			9
#define gk0			10
#define gk1			11
#define gk2			12
#define gk3			13
#define gk4			14
#define gk5			15
#define gk6			16
#define gk7			17
#define gk8			18
#define gk9			19
#define gkAdd			20
#define gkSub			21
#define gkMul			22
#define gkDiv			23
#define gkPow			24
#define gkRParen		25
#define gkTan			26
#define gkVars		27
#define gkDecPnt		28
#define gkLParen		29
#define gkCos			30
#define gkPrgm		31
#define gkStat		32
#define gkComma		33
#define gkSin			34
#define gkMatrix		35
#define gkGraphVar		36
#define gkStore		37
#define gkLn			38
#define gkLog			39
#define gkSquare		40
#define gkRecip		41
#define gkMath		42
#define gkGraph		43
#define gkTrace		44
#define gkZoom		45
#define gkWindow		46
#define gkYEqu		47
#define gkChs			48
#define gkMode		49

; ---------------------------------------------------------------
; Huffman code constants
; ---------------------------------------------------------------

#define hss                %011			; space ( )
#define hla                %0101
#define hle                %1110
#define hlr                %0011
#define hls                %1001
#define hlt                %1011
#define hs0                %1010			; null (~)
#define hlc                %00001
#define hld                %00100
#define hli                %11111
#define hll                %10000
#define hln                %11010
#define hlo                %11110
#define hlu                %00011
#define hsx                %010010			; exclamation (!)
#define huS                %001011
#define hlf                %110001
#define hlg                %000001
#define hlh                %110111
#define hlm                %010001
#define hlp                %100011
#define hlw                %000100
#define hly                %000101
#define hsq                %0100111		; quote (')
#define huA                %0010100
#define huB                %0100000
#define huP                %1100101
#define huR                %0000000
#define huT                %0000001
#define hlb                %1100000
#define hlk                %1100110
#define hlv                %0100001
#define huC                %11011011
#define huD                %11011010
#define huF                %10001010
#define huH                %11011000
#define huI                %01001100
#define huL                %10001000
#define huM                %01001101
#define huN                %10001011
#define hsp                %11001111		; TxtPKMN
#define hst                %00101011		; TxtTrgt
#define hsa                %11001000		; TxtAtk
#define hsd                %110010011		; Period (.)
#define huE                %110110010
#define huG                %100010010
#define huK                %110011100
#define huO                %110000110
#define huW                %110000111
#define hlz                %110000100
#define hsc                %1101100111		; Comma (,)
#define hsy                %1100100101		; Hyphen (-)
#define hn1                %0010101010
#define hn2                %1100111010
#define huU                %1100111011
#define hlx                %1100001011
#define hn5                %10001001101
#define hsu                %00101010011		; Question mark (?)
#define huQ                %00101010110
#define hsz                %11001001000		; TxtStat
#define hsb                %11000010100		; TxtAbil
#define hsm                %00101010001		; TxtMove
#define hsv                %11000010101		; TxtTeam
#define huV                %00101010111
#define hlq                %10001001110
#define hs6                %100010011110		; $06 space
#define hsf                %100010011001		; Forward slash (/)
#define hn0                %110010010011
#define hn3                %110110011000
#define hsn                %001010100100		; TxtNum
#define hsi                %001010100101		; TxtItem
#define huY                %110110011010
#define huZ                %100010011111
#define hlj                %110010010010
#define hn4                %1101100110010
#define hn6                %0010101000000
#define hso                %0010101000001		; Colon (:)
#define hs@                %0010101000010		; Ampersand (@)
#define huJ                %1101100110111
#define hse                %0010101000011		; TxtE, accented e
#define hs2                %1000100110000		; TxtMove2
#define hs3                %1000100110001		; TxtMove3
#define hsh                %11011001100110	; Hashtag (#)
#define hsl                %11011001100111	; Left paren (()
#define hsr                %11011001101100	; Right paren ())
#define hsk                %11011001101101	; Add or Plus (+)

;#define hsk                %110110011011010	; Add or Plus (+)
;#define huX                %110110011011011	; X
