; ===============================================================
; Graphics
; ===============================================================

; ===============================================================
; Sprite Data (8 pixels wide)
; Sprite:
; .db Height
; .db Data
; ===============================================================

; ---------------------------------------------------------------
; Pokeball
; Mini pokeball used in main menu
; 6 x 8
; ---------------------------------------------------------------

sPokeball:
 .db 6
 .db $30
 .db $78
 .db $B4
 .db $A4
 .db $48
 .db $30

sPokeball2:
 .db $30
 .db $48
 .db $CC
 .db $B4
 .db $48
 .db $30
 
; ---------------------------------------------------------------
; PokeballB
; The larger pokeball, used in pkmn select
; 9 x 16
; ---------------------------------------------------------------

sPokeballB:
 .db 9, 2
 .db $3F,$00
 .db $7F,$80
 .db $EF,$C0
 .db $EF,$C0
 .db $BF,$40
 .db $92,$40
 .db $C0,$C0
 .db $6D,$80
 .db $3F,$00

sPokeballB2:

 .db $1E,$00
 .db $21,$00
 .db $40,$80
 .db $80,$40
 .db $C0,$C0
 .db $AD,$40
 .db $52,$80
 .db $21,$00
 .db $1E,$00
 
; ---------------------------------------------------------------
; PokeballD
; Darker, shaded in pokeball, used in pkmn select
; 9 x 16
; ---------------------------------------------------------------

sPokeballD:
 .db 9, 2
 .db $3F,$00
 .db $61,$80
 .db $C0,$C0
 .db $80,$40
 .db $C0,$C0
 .db $AD,$40
 .db $D2,$C0
 .db $6D,$80
 .db $3F,$00

sPokeballD2:
 .db $1E,$00
 .db $3F,$00
 .db $6F,$80
 .db $EF,$C0
 .db $FF,$C0
 .db $BF,$40
 .db $52,$80
 .db $21,$00
 .db $1E,$00

; ---------------------------------------------------------------
; Empty Pokeball
; Unfilled pokeball used in battle screen
; 6 x 8
; --------------------------------------------------------------- 

sEmptyBall:
 .db 6
 .db $30
 .db $48
 .db $84
 .db $84
 .db $48
 .db $30

sEmptyBall2:
 .db $30
 .db $48
 .db $84
 .db $84
 .db $48
 .db $30
 
; --------------------------------------------------------------- 
; Fainted Pokeball
; Filled pokeball used in battle screen
; 6 x 8
; --------------------------------------------------------------- 

sFNTBall:
 .db 6
 .db $30
 .db $48
 .db $84
 .db $84
 .db $48
 .db $30

sFNTBall2:
 .db $30
 .db $78
 .db $FC
 .db $FC
 .db $78
 .db $30
 
; --------------------------------------------------------------- 
; Status Pokeball
; Darked pokeball used in battle screen
; 6 x 8
; --------------------------------------------------------------- 

sStatusBall:
 .db 6
 .db $30
 .db $48
 .db $CC
 .db $FC
 .db $78
 .db $30

sStatusBall2:
 .db $30
 .db $78
 .db $FC
 .db $B4
 .db $48
 .db $30

; ---------------------------------------------------------------
; MaleSymb
; Inverted symbol for male gender, used in info screen
; 7 x 8
; ---------------------------------------------------------------

sMaleSymb:
 .db 7
 .db $10
 .db $38
 .db $10
 .db $38
 .db $44
 .db $44
 .db $38

sMaleSymb2:
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 
; ---------------------------------------------------------------
; FemaleSymb
; Inverted symbol for female gender, used in info screen
; 7 x 8
; ---------------------------------------------------------------

sFemaleSymb:
 .db 7
 .db $38
 .db $44
 .db $44
 .db $38
 .db $10
 .db $7C
 .db $10

sFemaleSymb2:
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 .db $00
 
; ---------------------------------------------------------------
; BatDes
; Battle screen design for opp box
; 3 x 8
; ---------------------------------------------------------------

sBatDes:
 .db 3
 .db $80
 .db $C0
 .db $E0

sBatDes2:
 .db $80
 .db $C0
 .db $E0
 
; ---------------------------------------------------------------
; BatDesa
; Battle screen design for player box
; 3 x 8
; ---------------------------------------------------------------

sBatDesA:
 .db 3
 .db $01
 .db $03
 .db $07

sBatDesA2:
 .db $01
 .db $03
 .db $07
 
; ---------------------------------------------------------------
; BatBar
; Battle screen design for opp bar
; 3 x 8
; ---------------------------------------------------------------

sBatBar:
 .db 3
 .db $E0
 .db $F8
 .db $FE

sBatBar2:
 .db $C0
 .db $F0
 .db $FC
 
; ---------------------------------------------------------------
; BatBara
; Battle screen design for player bar
; 3 x 8
; ---------------------------------------------------------------

sBatBarA:
 .db 3
 .db $07
 .db $1F
 .db $7F

sBatBarA2:
 .db $03
 .db $0F
 .db $3F

; ===============================================================
; Sprite Data
; Sprite:
; .db Height, Width / 8
; .db Data
; ===============================================================

; ---------------------------------------------------------------
; PkmnLogo
; Pokemon title used in main menu, split into 2 parts (~200 b)
; 23 x 72
; ---------------------------------------------------------------

sPkmnLogo:
 .db 12, 9
 .db $00,$00,$00,$00,$1C,$00
 .db $00,$00,$00,$00,$00,$00,$00,$3E,$00
 .db $00,$00,$00,$00,$00,$00,$00,$3F,$00
 .db $00,$00,$00,$00,$00,$00,$00,$67,$00
 .db $00,$00,$00,$00,$00,$07,$F9,$CE,$3F
 .db $C6,$00,$00,$07,$FE,$1F,$FB,$BD,$FE
 .db $C7,$C0,$00,$3E,$0F,$1C,$6F,$FF,$CC
 .db $44,$FC,$00,$F0,$03,$9A,$47,$83,$8C
 .db $6C,$7F,$C0,$E0,$01,$DE,$06,$71,$88
 .db $7E,$3E,$C0,$E0,$71,$FE,$0E,$77,$80
 .db $77,$1C,$C0,$F8,$F1,$8E,$1C,$6F,$80
 .db $D3,$9C,$C0,$7C,$7B,$46,$0E,$08,$40
 .db $91,$98,$C0

sPkmnLogo2:
 .db $00,$00,$00,$00,$18,$00
 .db $00,$00,$00,$00,$00,$00,$00,$1C,$00
 .db $00,$00,$00,$00,$00,$00,$00,$66,$00
 .db $00,$00,$00,$00,$00,$00,$00,$C3,$00
 .db $00,$00,$00,$00,$00,$03,$F1,$86,$1F
 .db $C4,$00,$00,$03,$FC,$0E,$7B,$1D,$FC
 .db $47,$80,$00,$1C,$06,$18,$77,$E7,$9C
 .db $44,$F8,$00,$60,$01,$1E,$63,$01,$8C
 .db $46,$3F,$80,$C0,$01,$9E,$43,$33,$8C
 .db $7E,$1C,$40,$C0,$E0,$FE,$04,$67,$08
 .db $62,$1C,$40,$70,$79,$86,$0C,$4D,$80
 .db $49,$18,$C0,$3C,$71,$22,$04,$10,$C0
 .db $D0,$88,$80
 
sPkmnLogo3:
 .db 11, 9
 .db $3C,$77,$40,$06,$01,$94
 .db $98,$81,$80,$1E,$0E,$60,$03,$87,$1C
 .db $8E,$81,$80,$0F,$0E,$38,$30,$FF,$1C
 .db $C1,$81,$00,$07,$0E,$02,$3C,$3F,$BC
 .db $E3,$E3,$00,$07,$8F,$02,$3F,$17,$FE
 .db $7F,$63,$00,$03,$8F,$9F,$6F,$F0,$FF
 .db $7E,$66,$00,$03,$C7,$FF,$E3,$F0,$0F
 .db $FF,$E6,$00,$01,$C7,$EF,$E0,$00,$00
 .db $FF,$ED,$DF,$01,$DE,$00,$00,$00,$00
 .db $01,$FC,$9F,$00,$FC,$00,$00,$00,$00
 .db $00,$7C,$91,$00,$F0,$00,$00,$00,$00
 .db $00,$00,$00
 
sPkmnLogo4:
 .db $3E,$22,$42,$03,$00,$80
 .db $92,$88,$80,$0E,$06,$4A,$21,$03,$94
 .db $9C,$81,$00,$06,$0C,$72,$21,$FE,$1C
 .db $80,$A1,$00,$07,$0E,$02,$38,$1F,$1E
 .db $41,$21,$00,$03,$0E,$06,$3E,$13,$FE
 .db $26,$62,$00,$03,$87,$0E,$27,$90,$6E
 .db $3C,$E2,$00,$01,$85,$FF,$E1,$F0,$07
 .db $FE,$E4,$00,$01,$C4,$E7,$C0,$00,$00
 .db $77,$E5,$DB,$00,$CE,$00,$00,$00,$00
 .db $00,$EC,$95,$00,$F8,$00,$00,$00,$00
 .db $00,$38,$91,$00,$60,$00,$00,$00,$00
 .db $00,$00,$00

; ---------------------------------------------------------------
; BFTitle
; Sprite of Battle Factory title, used in main menu
; 15 x 40
; ---------------------------------------------------------------

sBFTitle:
 .db 15, 5
 .db $FD,$F7,$F7,$F7,$1F
 .db $FD,$F7,$F7,$F7,$1F
 .db $FD,$F7,$F7,$F7,$1F
 .db $FD,$F1,$C1,$C7,$1F
 .db $FD,$F1,$C1,$C7,$DF
 .db $FD,$F1,$C1,$C7,$DF
 .db $FD,$F1,$C1,$C7,$DF
 .db $00,$00,$00,$00,$00
 .db $FB,$EF,$7D,$F7,$DF
 .db $FB,$EF,$7D,$F7,$DF
 .db $FB,$EF,$7D,$F7,$DF
 .db $F3,$EE,$39,$F7,$DF
 .db $F3,$EF,$39,$F7,$DF
 .db $E3,$EF,$39,$F7,$CE
 .db $E3,$EF,$39,$F7,$CE

sBFTitle2:

 .db $FD,$F7,$F7,$F7,$1F
 .db $85,$14,$14,$15,$11
 .db $B5,$57,$77,$75,$17
 .db $85,$11,$41,$45,$11
 .db $B5,$51,$41,$45,$D7
 .db $85,$51,$41,$44,$51
 .db $FD,$F1,$C1,$C7,$DF
 .db $00,$00,$00,$00,$00
 .db $FB,$EF,$7D,$F7,$DF
 .db $8A,$29,$45,$14,$55
 .db $BA,$AB,$6D,$55,$55
 .db $92,$2A,$29,$54,$D1
 .db $B2,$AB,$29,$55,$5B
 .db $A2,$A9,$29,$15,$4A
 .db $E3,$EF,$39,$F7,$CE

; ---------------------------------------------------------------
; BFLogo
; Frontier symbol used in main menu
; 23 x 24
; ---------------------------------------------------------------

sBFLogo:
 .db 23, 3
 .db $00
 .db $7F,$00,$00
 .db $BE,$80,$01
 .db $7F,$40,$02
 .db $E3,$A0,$05
 .db $DD,$D0,$07
 .db $A2,$F0,$07
 .db $80,$F0,$07
 .db $36,$70,$0E
 .db $C9,$B8,$11
 .db $AA,$C4,$2B
 .db $1C,$6A,$5A
 .db $7F,$2D,$78
 .db $1C,$0F,$F8
 .db $2A,$0F,$F0
 .db $08,$07,$F4
 .db $00,$17,$F4
 .db $00,$17,$F6
 .db $00,$37,$78
 .db $00,$0F,$7F
 .db $41,$7F,$3F
 .db $E3,$FE,$1F
 .db $DD,$FC,$07
 .db $E3,$F0

sBFLogo2:
 .db $00
 .db $00,$00,$00
 .db $7F,$00,$00
 .db $FF,$80,$01
 .db $E3,$C0,$03
 .db $DD,$E0,$03
 .db $BE,$E0,$03
 .db $80,$E0,$03
 .db $3E,$60,$02
 .db $C1,$A0,$09
 .db $9C,$C8,$1B
 .db $3E,$6C,$3A
 .db $3E,$2E,$38
 .db $3E,$0E,$78
 .db $1C,$0F,$70
 .db $00,$07,$64
 .db $00,$13,$66
 .db $00,$33,$77
 .db $00,$77,$30
 .db $00,$06,$3F
 .db $80,$FE,$1F
 .db $F7,$FC,$07
 .db $E3,$F0,$00
 .db $00,$00
 
; ---------------------------------------------------------------
; KnowSymb
; Knowledge Symbol used in main menu
; 23 x 24
; ---------------------------------------------------------------

sKnowSymb:
 .db 23, 3
 .db $03,$FF,$80
 .db $07,$6D,$C0
 .db $1E,$D6,$F0
 .db $3B,$AB,$B8
 .db $77,$5D,$DC
 .db $6E,$BE,$EC
 .db $DD,$7F,$76
 .db $FE,$FE,$FE
 .db $BD,$7D,$7A
 .db $FA,$BA,$BE
 .db $F5,$55,$5E
 .db $EB,$AA,$EE
 .db $D7,$D5,$F6
 .db $AF,$EB,$FA
 .db $9F,$D7,$F2
 .db $EF,$BB,$EE
 .db $D7,$7D,$D6
 .db $6A,$FE,$AC
 .db $75,$FF,$5C
 .db $3B,$FF,$B8
 .db $1D,$FF,$70
 .db $0F,$7D,$E0
 .db $03,$FF,$80

sKnowSymb2:
 .db $01,$FF,$00
 .db $03,$93,$80
 .db $0F,$39,$E0
 .db $1C,$7C,$70
 .db $38,$E6,$38
 .db $71,$C3,$1C
 .db $63,$81,$8C
 .db $C1,$83,$06
 .db $C2,$C6,$86
 .db $87,$6D,$C2
 .db $8F,$BB,$E2
 .db $9C,$D7,$32
 .db $B8,$6E,$1A
 .db $F0,$3C,$0E
 .db $F0,$6C,$1E
 .db $D8,$C6,$36
 .db $6D,$83,$6C
 .db $77,$01,$DC
 .db $3A,$00,$B8
 .db $1C,$00,$70
 .db $0E,$00,$E0
 .db $07,$83,$C0
 .db $01,$FF,$00

; ---------------------------------------------------------------
; HeaderA
; Header used for info menu, tab 'Info'
; Must be contiguous w/ other headers (B and C)
; 6 x 16
; ---------------------------------------------------------------

sHeaderA:
 .db 6, 2
 .db $3F,$FC
 .db $1F,$FE
 .db $0F,$FF
 .db $0F,$FF
 .db $1F,$FE
 .db $3F,$FC

sHeaderA2:
 .db $C0,$00
 .db $E0,$00
 .db $33,$0C
 .db $33,$0C
 .db $E0,$00
 .db $C0,$00
 
; ---------------------------------------------------------------
; HeaderB
; Header used for info menu, tab 'Skills'
; 6 x 16
; ---------------------------------------------------------------

sHeaderB:
 .db 6, 2
 .db $00,$FC
 .db $00,$7E
 .db $C0,$3F
 .db $C0,$3F
 .db $00,$7E
 .db $00,$FC

sHeaderB2:
 .db $FF,$00
 .db $FF,$80
 .db $FC,$CC
 .db $FC,$CC
 .db $FF,$80
 .db $FF,$00
 
; ---------------------------------------------------------------
; HeaderC
; Header used for info menu, tab 'Moves'
; 6 x 16
; ---------------------------------------------------------------

sHeaderC:
 .db 6, 2
 .db $00,$00
 .db $00,$00
 .db $C3,$00
 .db $C3,$00
 .db $00,$00
 .db $00,$00

sHeaderC2:
 .db $FF,$FC
 .db $FF,$FE
 .db $FF,$F3
 .db $FF,$F3
 .db $FF,$FE
 .db $FF,$FC

; ---------------------------------------------------------------
; SelTCursor
; Cursor used in select team menu
; 6 x 8
; ---------------------------------------------------------------

sSelTCursor:
 .db 6
 .db $00
 .db $10
 .db $38
 .db $7C
 .db $00
 .db $FE

sSelTCursor2:
 .db $10
 .db $38
 .db $7C
 .db $FE
 .db $00
 .db $FE

; ---------------------------------------------------------------
; SelGradTL
; Select Team gradient pattern; top left
; 8 x 8
; ---------------------------------------------------------------

sSelGradTL:
 .db 8
 .db $80
 .db $40
 .db $A0
 .db $D0
 .db $E8
 .db $F4
 .db $FA
 .db $FD

sSelGradTL2:
 .db $00
 .db $80
 .db $C0
 .db $E0
 .db $F0
 .db $F8
 .db $FC
 .db $FE
 
; ---------------------------------------------------------------
; SelGradTR
; Select Team gradient pattern; top right
; 8 x 8
; ---------------------------------------------------------------

sSelGradTR:
 .db 8
 .db $BF
 .db $5F
 .db $2F
 .db $17
 .db $0B
 .db $05
 .db $02
 .db $01

sSelGradTR2:
 .db $7F
 .db $3F
 .db $1F
 .db $0F
 .db $07
 .db $03
 .db $01
 .db $00
 
; ---------------------------------------------------------------
; SelGradTRa
; Select Team gradient pattern; top right
; 6 x 8
; ---------------------------------------------------------------

sSelGradTRa:
 .db 6
 .db $7F
 .db $BF
 .db $5F
 .db $2F
 .db $17
 .db $0B

sSelGradTRa2:
 .db $FF
 .db $7F
 .db $3F
 .db $1F
 .db $0F
 .db $07
 
; ---------------------------------------------------------------
; SelGradTR3
; Select Team gradient pattern; top right
; 4 x 8
; ---------------------------------------------------------------

sSelGradTR3:
 .db 4
 .db $DC
 .db $6F
 .db $37
 .db $1F

sSelGradTR32:
 .db $E0
 .db $30
 .db $18
 .db $0F

; ---------------------------------------------------------------
; sPokeballC
; Closed pokeball, used in Party UI
; 9 x 16
; ---------------------------------------------------------------

sPokeballC:
 .db 9, 2
 .db $3E,$00
 .db $7F,$00
 .db $FF,$80
 .db $EB,$80
 .db $F7,$80
 .db $9C,$80
 .db $C1,$80
 .db $63,$00
 .db $3E,$00

sPokeballC2:
 .db $1C,$00
 .db $22,$00
 .db $41,$00
 .db $9C,$80
 .db $F7,$80
 .db $88,$80
 .db $41,$00
 .db $22,$00
 .db $1C,$00
 
; ---------------------------------------------------------------
; sPokeballO
; Open pokeball, used in Party UI
; 11 x 16
; ---------------------------------------------------------------

sPokeballO:
 .db 11, 2
 .db $3E,$00
 .db $7F,$00
 .db $FF,$80
 .db $EB,$80
 .db $F7,$80
 .db $08,$00
 .db $F7,$80
 .db $9C,$80
 .db $C1,$80
 .db $63,$00
 .db $3E,$00

sPokeballO2:
 .db $1C,$00
 .db $22,$00
 .db $41,$00
 .db $9C,$80
 .db $F7,$80
 .db $08,$00
 .db $E3,$80
 .db $9C,$80
 .db $41,$00
 .db $22,$00
 .db $1C,$00

Data_End:				; must be at end of data code
.echo "Data: "			; prints out amount of data in bytes
.echo Data_End - Data
.echo " bytes.\n"
